VERSION 5.00
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.2#0"; "comdlg32.ocx"
Begin VB.MDIForm MDIForm1 
   BackColor       =   &H8000000C&
   Caption         =   "DDE File Editor"
   ClientHeight    =   4680
   ClientLeft      =   165
   ClientTop       =   735
   ClientWidth     =   8940
   LinkMode        =   1  'Source
   LinkTopic       =   "DDEFileEditorMdiForm"
   StartUpPosition =   3  'Windows Default
   Begin VB.PictureBox Picture1 
      Align           =   1  'Align Top
      Height          =   495
      Left            =   0
      ScaleHeight     =   435
      ScaleWidth      =   8880
      TabIndex        =   0
      Top             =   0
      Visible         =   0   'False
      Width           =   8940
      Begin VB.TextBox Text1 
         Height          =   285
         Left            =   120
         TabIndex        =   1
         Text            =   "Text1"
         Top             =   120
         Width           =   1935
      End
   End
   Begin MSComDlg.CommonDialog dlgFile 
      Left            =   2160
      Top             =   1320
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   393216
      CancelError     =   -1  'True
      DefaultExt      =   "txt"
      DialogTitle     =   "Select File"
   End
   Begin VB.Menu mnuFile 
      Caption         =   "&File"
      Begin VB.Menu mnuFileOpen 
         Caption         =   "&Open"
         Shortcut        =   ^O
      End
   End
End
Attribute VB_Name = "MDIForm1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

' Grab a file's contents.
Private Function GrabFile(ByVal file_name As String) As String
Dim fnum As Integer
Dim txt As String

    fnum = FreeFile
    Open file_name For Input As #fnum
    txt = Input$(LOF(fnum), #fnum)
    Close #fnum

    GrabFile = txt
End Function

' At design time:
'       MDIForm.LinkMode = Source
'       MDIForm.LinkTopic = DDEFileEditorMdiForm
'       Save project as DDEFileEditor.vbp
Private Sub MDIForm_Load()
Dim cap As String

    ' See if there is a previous instance.
    If App.PrevInstance Then
        ' DDE Destination.

        ' See if we have command-line arguments.
        If Len(Command$) > 0 Then
            ' Clear any existing DDE link.
            Text1.LinkMode = vbLinkNone

            ' Define link to source.
            Text1.LinkTopic = _
                "DDEFileEditor|" & _
                "DDEFileEditorMdiForm"

            ' Link to Source.Text1.
            Text1.LinkItem = "Text1"

            ' Establish manual link.
            Text1.LinkMode = vbLinkManual
            DoEvents

            ' Push the command-line arguments.
            Text1.Text = Command$
            Text1.LinkPoke

            ' Activate the running instance.
            cap = Me.Caption
            Me.Caption = ""
            AppActivate cap
        End If

        ' Exit.
        Unload Me
    Else
        ' DDE Source.
        dlgFile.Flags = _
            cdlOFNFileMustExist Or _
            cdlOFNLongNames Or _
            cdlOFNHideReadOnly
        dlgFile.CancelError = True
        dlgFile.Filter = "Text Files (*.txt)|*.txt|All Files (*.*)|*.*"
        dlgFile.InitDir = App.Path

        ' Process the command-line arguments.
        Text1.Text = Command$
    End If
End Sub
Private Sub mnuFileOpen_Click()
Dim frm As frmEditor

    On Error Resume Next
    dlgFile.ShowOpen
    If Err.Number = cdlCancel Then
        ' Canceled.
    ElseIf Err.Number <> 0 Then
        ' Error.
        MsgBox "Error selecting file.", , vbExclamation
    Else
        ' Open the file.
        Set frm = New frmEditor
        frm.Caption = "[" & dlgFile.FileName & "]"
        frm.Text1 = GrabFile(dlgFile.FileName)
        frm.Show
    End If
End Sub
Private Sub Text1_Change()
Dim files() As String
Dim i As Integer
Dim frm As frmEditor

    If App.PrevInstance Then Exit Sub
    If Len(Text1.Text) = 0 Then Exit Sub
    files = Split(Text1.Text)
    Text1.Text = ""

    For i = LBound(files) To UBound(files)
        Set frm = New frmEditor
        frm.Caption = "[" & LongFileName(files(i)) & "]"
        frm.Text1 = GrabFile(files(i))
        frm.Show
    Next i
End Sub


' Return the file's long name.
Public Function LongFileName(ByVal short_name As String) As String
Dim pos As Integer
Dim result As String
Dim long_name As String

    ' Start after the drive letter if any.
    If Mid$(short_name, 2, 1) = ":" Then
        result = Left$(short_name, 2)
        pos = 3
    Else
        result = ""
        pos = 1
    End If

    ' Consider each section in the file name.
    Do While pos > 0
        ' Find the next \.
        pos = InStr(pos + 1, short_name, "\")

        ' Get the next piece of the path.
        If pos = 0 Then
            long_name = Dir$(short_name, vbNormal + _
                vbHidden + vbSystem + vbDirectory)
        Else
            long_name = Dir$(Left$(short_name, pos - 1), _
                vbNormal + vbHidden + vbSystem + _
                vbDirectory)
        End If
        result = result & "\" & long_name
    Loop

    LongFileName = result
End Function


